//     DPMI stuff.
//
//                             Fernando Anton - Mitra / Spanish Lords
//                                                  fernando@ergos.es

#include "slints.hpp"
#include <mem.h>
#include <i86.h>

// Structures for the processor registers.
SREGS sregs;
REGS  inregs,outregs;

// Library functions.
void GetRMInt(unsigned char Num,unsigned short &Segmento,unsigned short &Offset)
{
   memset(&sregs,0,sizeof(sregs));
   memset(&inregs,0,sizeof(inregs));
   inregs.x.eax = 0x0200;
   inregs.h.bl  = Num;
   int386 (0x31, &inregs, &outregs);
   Segmento = outregs.w.cx;
   Offset   = outregs.w.dx;
}
int  SetRMInt(unsigned char Num,unsigned short Segmento,unsigned short Offset)
{
   memset(&sregs,0,sizeof(sregs));
   memset(&inregs,0,sizeof(inregs));
   inregs.x.eax = 0x0201;
   inregs.h.bl  = Num;
   inregs.w.cx  = Segmento;
   inregs.w.dx  = Offset;
   int386 (0x31, &inregs, &outregs);
   if (outregs.x.cflag&1) return(0); else return(1);
}
void GetPMInt(unsigned char Num,unsigned short &Selector,unsigned long &Offset)
{
   memset(&sregs,0,sizeof(sregs));
   memset(&inregs,0,sizeof(inregs));
   inregs.x.eax = 0x0204;
   inregs.h.bl  = Num;
   int386 (0x31, &inregs, &outregs);
   Selector = outregs.w.cx;
   Offset   = outregs.x.edx;
}
int  SetPMInt(unsigned char Num,unsigned short Selector,unsigned long Offset)
{
   memset(&sregs,0,sizeof(sregs));
   memset(&inregs,0,sizeof(inregs));
   inregs.x.eax = 0x0205;
   inregs.h.bl  = Num;
   inregs.w.cx  = Selector;
   inregs.x.edx = Offset;
   int386 (0x31, &inregs, &outregs);
   if (outregs.x.cflag&1) return(0); else return(1);
}
int  GetDOSMem(unsigned short NPara,unsigned short &Segmento,unsigned short &Selector)
{
   memset(&sregs,0,sizeof(sregs));
   memset(&inregs,0,sizeof(inregs));
   segread(&sregs);
   inregs.w.ax=0x0100;
   inregs.w.bx=NPara;
   int386x( 0x31, &inregs, &outregs, &sregs);
   Segmento=outregs.w.ax;
   Selector=outregs.w.dx;
   if (outregs.x.cflag&1)
   {
      Segmento=outregs.w.bx;
      return(0);
   }
   else return(1);
}
int  FreeDOSMem(unsigned short &Selector)
{
   memset(&sregs,0,sizeof(sregs));
   memset(&inregs,0,sizeof(inregs));
   segread(&sregs);
   inregs.w.ax=0x0101;
   inregs.w.dx=Selector;
   int386x( 0x31, &inregs, &outregs, &sregs);
   if (outregs.x.cflag&1) return(0); else return(1);
}

